<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.1.00  
* Copyright (C) 2007-2012 Fred Stuurman (fc.stuurman@gmail.com)
* Core function:
* pag_modbrowser.inc.php: last changed 11/03/2011 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

define('IN_SAS', true);

include ("../configuration/database.inc.php"); // connecting to database
$db = new mysqli($db_server, $db_username, $db_password, $db_name);
require ("../core/session.php"); //build a session

$query = "SELECT config_value FROM $table_configuration WHERE config_key='sessioncode'";

if ($result = mysqli_query($db, $query))
{
	$check_sessioncode = mysqli_result($result, 0, 'config_value');
	unset ($query);
	unset ($result);
}
if ($_SESSION['sessioncode'] != "$check_sessioncode")
{
	//if we don't have a session present the login screen
	Header("Location: ../index.php");
	exit;
}

unset ($sas_lang);
$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'language'"; // getting the language
$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
$language = mysqli_result($result, 0, 'config_value');
include ("../languages/$language/$language.php"); // including language file
unset ($query);
unset ($result);

if (IsSet ($_GET['module']))
{
	$module = intval($_GET['module']);
}
else
{
	unset ($module);
}
$option = "";
if (IsSet ($_GET['option']))
{
	$option = intval($_GET['option']);
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $sas_lang['lang_charset'] ?>"> 
<title>SyndeoCMS</title>
<link rel="StyleSheet" href="../interface/style.css" type="text/css" />
</head>
<body style="font-family: Verdana, Arial, Helvetica; font-size: 10pt" bgcolor="#F7F7F7">

<?php

print "
<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" height=\"27\" bgcolor=\"#0D85BB\">
  <tr>
    <td width=\"100%\" align=\"right\"><b><font face=\"Verdana\" color=\"#FFFFFF\" size=\"4\">" . $sas_lang['modulebrowser'] . "&nbsp;&nbsp;</font></b></td>
  </tr>
</table>";
print "<table cellSpacing=0 cellPadding=0 width=\"100%\" height=\"373\" border=0>
  <tbody>
  <tr>
    <td width=1 bgcolor=\"#ffffff\">&nbsp;</td>
    <td vAlign=\"top\" width=\"258\" bgColor=\"#f7f7f7\">
      <table>
        <tbody>
        <tr><td><span class=\"sas_module_subtitle\">" . $sas_lang['module_name'] . "</span></td></tr>
        <tr>
          <td>";

$query = "SELECT id, name FROM $table_modules WHERE options != '' ORDER BY name"; // getting module list
$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
while ($module_list = mysqli_fetch_array($result))
{
	print "<img src=\"../graphics/module.gif\">&nbsp;<a href=\"pag_modbrowser.inc.php?module=$module_list[0]\">$module_list[1]</a><br>";
}
print " </td>
        </tr>
      </tbody>
     </table>
    </td>
    <td width=\"1\" bgcolor=\"#e5e5e5\"><IMG src=\"../graphics/pixel.gif\"></td>
    <td valign=\"top\">
    <table border=\"0\" width=\"100%\">";
if (!IsSet ($module))
{
	print "<tr><td height=\"353\" valign=\"top\"><br />" . $sas_lang['modbrowser_introduction'];
}
else
{
	$query = "SELECT location, options, name FROM $table_modules WHERE id = '" . $module . "'"; // getting the location
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
	$modlocation = mysqli_result($result, 0, 'location');
	$options = mysqli_result($result, 0, 'options');
	$modname = mysqli_result($result, 0, 'name');
	unset ($query);
	unset ($result);
	
	$where_extra = "WHERE public = 0"; //default public site.
	$public = 0 ;
	
	if($_SESSION['site'] == "protected")
	{
		$where_extra = "WHERE public = 1";
		$public = 1;
	}
	
	//set the tabelname and field to be slected for modules with extra options
	if($modlocation == "sn_ads")
	{
		$table = $dbprefix . "m_adtext_cat";
		$field = "name";
	}
	if($modlocation == "sn_form")
	{
		$table = $dbprefix . "m_forms_config";
		$field = "form_name";
		$where_extra = ""; //Forms don't have protected flag.
	}
	if($modlocation == "sn_allbum")
	{
		$table = $dbprefix . "m_album_cat";
		$field = "pagename";
		
		$where_extra = "WHERE public = 0 AND publish = 1"; //default public site.
		
		if($_SESSION['site'] == "protected")
		{
			$where_extra = "WHERE public = 1 AND publish = 1";
		}
	}
	if($modlocation == "sn_gbook")
	{
		$table = $dbprefix . "m_gbook_cat";
		$field = "name";
	}
	if($modlocation == "sn_links")
	{
		$table = $dbprefix . "m_links_cat";
		$field = "pagename";
	}
	if($modlocation == "sn_portal")
	{
		$table = $dbprefix . "m_portal_pages";
		$field = "pagename";
		$where_extra = ""; //Portal don't have protected flag.
	}
	if($modlocation == "sn_message")
	{
		$table = $dbprefix . "m_message_cat";
		$field = "pagename";
	}
	if($modlocation == "sn_calendar")
	{
		$table = $dbprefix . "m_calendars";
		$field = "name";
		$where_extra = ""; //Calendar don't have protected flag.
	}
	if($modlocation == "video")
	{
		$table = $dbprefix . "m_videos";
		$field = "name";
	}
	if($modlocation == "sn_news")
	{
		$table = $dbprefix . "m_news_cat";
		$field = "title";
		$where_extra = "WHERE ispage = 1"; //only show news categries connected to a page.
	}
	if($modlocation == "sn_newsletter")
	{
		$table = $dbprefix . "m_newsletter_cat";
		$field = "name";
	}
	if($modlocation == "pdf")
	{
		$table = $dbprefix . "m_pdf";
		$field = "name";
		$where_extra = ""; //Pdf don't have protected flag.
	}
	if($modlocation == "sn_downloads")
	{
		$table = $dbprefix . "m_downloads_cat";
		$field = "title";
	}
	if($modlocation == "poll")
	{
		$table = $dbprefix . "m_poll_config";
		$field = "title";
		$where_extra = ""; //Forms don't have protected flag.
	}
	if($modlocation == "sn_studentpages")
	{
		$table = $dbprefix . "classes";
		$field = "name";
		if($option == 6)
		{
			$where_extra = "WHERE project = 0 AND name != '**dummy**' ";	//filter the dummy class
		}
		else
		{
			$where_extra = "WHERE project = 1 ";
		}
	}
	
	$options = explode(",", $options);
	$count = count($options);	//every module option has 3 options: name , scriptname and options (0/1)
	
	print "<tr><td><span class=\"sas_module_subtitle\">" . $modname . ":</span></td></tr>
			<tr><td height=\"417\" valign=\"top\"><div style=\"margin-left: 10px;\"><p>";
	
	for ($i = 0; $i <= $count-1; $i++) 
	{
		if($options[$i+2] == 0)		//do we have extra options
		{
			print "<p><a href=\"#\" OnClick=\"opener.document.theForm.module.value = '$modlocation/$options[$i]'; self.close();\">" . $options[$i+1] . "</a><p>";
		}
		else
		{
			if($count == 3) //only 1 module option
			{
				print $options[$i+1] . ":<p>"; 	//option name
				//select the paganame for the module
				$query = "SELECT $field FROM $table $where_extra ORDER BY $field";
				$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);
				$ops_count = mysqli_num_rows($result) ;
				if($ops_count == 0)
				{
					print $sas_lang['no_module_options'];
				}
				else
				{
					while ($page_list = mysqli_fetch_array($result))
					{
						$value = addslashes($page_list[0]) ;
						print "<span style=\"margin-left: 20px;\">
							<a href=\"#\" OnClick=\"opener.document.theForm.module.value = '$modlocation/$options[$i]'; opener.document.theForm.title.value = '$page_list[0]'; self.close();\">" . 
							$page_list[0] . "</a></span><br />";
					}	
				}
			}
			else
			{
				if($option === $i)
				{
					print "<a href=\"pag_modbrowser.inc.php?module=$module&option=$i\" style=\"font-weight: normal;\">" . $options[$i+1] . ":</a><p>";	//link is used to present module pagenames
				}
				else
				{
					print "<a href=\"pag_modbrowser.inc.php?module=$module&option=$i\">" . $options[$i+1] . "</a>
						<img src=\"../graphics/triangle.gif\" style=\"margin-bottom: -3px;\" /><p>";	//link is used to present module pagenames
				}
			}
			
			if((isset($option)) AND ($option == $i) AND ($count != 3))
			{
				//select the paganame for the module
				$query = "SELECT $field FROM $table $where_extra ORDER BY $field";
						
				if(($option == 9) AND ($modlocation == "pictures"))	//special case for pictues module, overview albums
				{
					$query = "SELECT overview_name FROM $table WHERE public = $public AND publish = 1 AND archive = 0 AND overview_name != '' 
							GROUP BY overview_name ORDER BY overview_name";
				}

				$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
				while ($page_list = mysqli_fetch_array($result))
				{
					print "<span style=\"margin-left: 20px;\">
						<a href=\"#\" OnClick=\"opener.document.theForm.module.value = '$modlocation/$options[$i]'; opener.document.theForm.title.value = '$page_list[0]'; self.close();\">" . 
						$page_list[0] . "</a></span><br />";

				}
				print "<p>&nbsp;</p>";
			}
		}
		$i = $i + 2;
	}
}

print "</div></td></tr>
      <tr>
       <td width=\"100%\" align=\"right\" valign=\"bottom\">";
print "<button onclick=\"javascript:self.close();\" type=\"button\" class=\"button\"><em><span>".$sas_lang['close']."</span></em></button>";
	
print "</td>
      </tr>
    </table>
    </td>
  </tr>
 </tbody>
</table>
</body>
</html>";

//needed for the conversion to mysqli because mysql_result does
function mysqli_result($res, $row, $field=0) 
{ 
    $res->data_seek($row); 
    $datarow = $res->fetch_array(); 
    return $datarow[$field]; 
}
?>