<?php
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

/*
** DGS Search
** utils.php written by James Sella and William Sella
** Copyright (c) 2000-2001 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
** adapted to work with the language file from S@S, instead of the DGS SEARCH one's.
** fc.stuurman (fc.stuurman@gmail.com)
#$Id: utils.php,v 1.1 2006/10/03 08:54:49 fstuurman Exp $
*/

function getHtmlTitle($file)
{
	global $config;

	$warn = false;

	if ($warn)
	{
		$buffer = file($file); //Without @ will show SAFE MODE warnings.
	}
	else
	{
		$buffer = @ file($file); //Hide warnings.
	}

	if (!is_array($buffer))
		return;

	$buffer = implode(' ', $buffer);
	$lowBuffer = strtolower($buffer);

	/* Locate where <TITLE> is located in html file. */
	$lBound = strpos($lowBuffer, '<title>') + 7; //7 is the lengh of <TITLE>.

	if ($lBound < 1)
		return;

	/* Locate where </TITLE> is located in html file. */
	$uBound = strpos($lowBuffer, '</title>', $lBound);

	if ($uBound < $lBound)
		return;

	/* Clean HTML and PHP tags out of $title with the madness below. */
	$title = preg_replace("/[\t\n\r]/", '', substr($buffer, $lBound, $uBound - $lBound));
	$title = trim(strip_tags($title));

	if (strlen($title) < 1) //A blank title is worthless.
		return;

	return $title;
}

function getMetaDesc(& $content)
{
	global $config;

	$lowBuffer = strtolower($content);

	/* Locate where <META is located in html file. */
	$lBound = strpos($lowBuffer, '<meta');

	if ($lBound < 1)
		return false;

	/* Locate where </HEAD is located in html file. */
	$uBound = strpos($lowBuffer, '</head', $lBound);

	if ($uBound < $lBound)
		return false;

	/* Clean HTML and PHP tags out of $desc with the madness below. */
	$desc = preg_replace("/[\t\r\n]/", '', substr($content, $lBound, $uBound - $lBound));
	$desc = preg_replace('/^.*<META[[:space:]]+NAME[[:space:]]*=[[:space:]]*\"?description\"?[[:space:]]+CONTENT[[:space:]]*=[[:space:]]*\"?([^\">]*).*$', '\\1/', $desc);
	$desc = trim(strip_tags($desc));

	if (strlen($desc) < 1) //A blank desc is worthless.
		return false;

	return $desc;
}

function strimatch($string1, $string2)
{
	for ($i = 0; $i < strlen($string1) && $i < strlen($string2); $i++)
	{
		if (strtolower($string1[$i]) != strtolower($string2[$i]))
		{
			break;
		}
	}

	return substr($string1, 0, $i);
}

function strmatch($string1, $string2)
{
	for ($i = 0; $i < strlen($string1) && $i < strlen($string2); $i++)
	{
		if ($string1[$i] != $string2[$i])
		{
			break;
		}
	}

	return substr($string1, 0, $i);
}

function getTime()
{
	if (function_exists('microtime'))
	{
		$tm = microtime();
		$tm = explode(' ', $tm);
		return (float) sprintf('%f', $tm[1] + $tm[0]);
	}

	return time();
}

function processWindow(& $content, $width, $height, $q, $matchCount)
{
	global $config;
	$keywords_array = explode(" ", $q);
	$q = $keywords_array[0]; //only use the first keyword to get description
	$lowQ = strtolower($q);
	$qSize = strlen($q);
	$window = $width / 2;
	$descEnd = '...';
	$stripTags = true;
	$desc = array ();

	$content = str_replace('<br', ' <br', $content);
	$content = str_replace('<Br', ' <Br', $content);
	$content = str_replace('<BR', ' <BR', $content);
	$content = str_replace('<p', ' <p', $content);
	$content = str_replace('<P', ' <P', $content);
	$content = str_replace('&nbsp;', ' ', $content); //'&nbsp' parts show up if they are broken, so convert to spaces.

	if ($stripTags)
		$content = strip_tags($content);

	$content = preg_replace('/[[:space:]]{2,}/', ' ', $content); //Consume extra whitespace from content.
	$content = trim($content);

	$lowContent = strtolower($content);
	$contentSize = strlen($content);

	$queryIdx = 0;
	for ($i = 0; $i < $height; $i++)
	{
		$queryIdx = strpos($lowContent, $lowQ, $queryIdx);
		if (!is_int($queryIdx) || $queryIdx >= $contentSize) //If we don't find $q, then there are no more matches.
			break;

		/* Grab the section of text around the matching keyword. */
		$lBound = ($queryIdx - $window < 0) ? 0 : $queryIdx - $window;
		$uBound = ($lBound + $width > $contentSize) ? $contentSize : $lBound + $width;
		$lBound = ($uBound < $contentSize) ? $lBound : (($uBound - $width < 1) ? 0 : $uBound - $width);

		/* Slide our window to avoid cutting words. */
		$descAdj = $uBound - ($queryIdx + $qSize);
		for ($j = 0; $j < $descAdj; $j++)
		{
			if ($lBound - $j <= 0 || $content[$lBound - $j -1] == ' ')
			{
				$lBound -= $j;
				$uBound -= $j;
				break;
			}
		}

		/* Shrink the uBound to avoid cutting words. */
		$descAdj = $uBound - ($queryIdx + $qSize);
		if ($uBound < $contentSize && $content[$uBound] != ' ')
		{
			for ($j = 1; $j < $descAdj; $j++)
			{
				if ($content[$uBound - $j] == ' ' && $uBound - $j > $lBound)
				{
					$uBound -= $j;
					break;
				}
			}
		}

		/* Cut the desc out of content and add descEnd. */
		$descBuf = '';
		if ($lBound > 0)
			$descBuf = $descEnd;
		$descBuf .= trim(substr($content, $lBound, $uBound - $lBound));
		if ($uBound < $contentSize)
			$descBuf .= $descEnd;
		foreach ($keywords_array as $value)
		{
			$descBuf = preg_replace("/($value)/", "<b>\\1</b>", $descBuf);
		}
		$desc[$i] = $descBuf;
		$queryIdx = $uBound; //Jump the queryIdx to the end of the desc.
	}
	return $desc;
}
?>